KUBERNETES(1)

NAME

kubectl run - Run a particular image on the cluster.

SYNOPSIS

kubectl run [OPTIONS]

DESCRIPTION

Create and run a particular image, possibly replicated. Creates a deployment or job to manage the created container(s).

OPTIONS

--attach=false
    If true, wait for the Pod to start running, and then attach to the Pod as if 'kubectl attach ...' were called. Default false, unless '-i/--interactive' is set, in which case the default is true.

--command=false
    If true and extra arguments are present, use them as the 'command' field in the container, rather than the 'args' field which is the default.

--dry-run=false
    If true, only print the object that would be sent, without sending it.

--env=[]
    Environment variables to set in the container

--expose=false
    If true, a public, external service is created for the container(s) which are run

--generator=""
    The name of the API generator to use. Default is 'deployment/v1beta1' if --restart=Always, otherwise the default is 'job/v1beta1'.

--hostport=-1
    The host port mapping for the container port. To demonstrate a single-machine container.

--image=""
    The image for the container to run.

-l, --labels=""
    Labels to apply to the pod(s).

--leave-stdin-open=false
    If the pod is started in interactive mode or with stdin, leave stdin open after the first attach completes. By default, stdin will be closed after the first attach completes.

--limits=""
    The resource requirement limits for this container. For example, 'cpu=200m,memory=512Mi'

--no-headers=false
    When using the default output, don't print headers.

-o, --output=""
    Output format. One of: json|yaml|wide|name|go-template=...|go-template-file=...|jsonpath=...|jsonpath-file=... See golang template [ ⟨http://golang.org/pkg/text/template/#pkg-overview⟩] and jsonpath template [ ⟨http://releases.k8s.io/HEAD/docs/user-guide/jsonpath.md⟩].

--output-version=""
    Output the formatted object with the given version (default api-version).

--overrides=""
    An inline JSON override for the generated object. If this is non-empty, it is used to override the generated object. Requires that the object supply a valid apiVersion field.

--port=-1
    The port that this container exposes. If --expose is true, this is also the port used by the service that is created.

--record=false
    Record current kubectl command in the resource annotation.

-r, --replicas=1
    Number of replicas to create for this container. Default is 1.

--requests=""
    The resource requirement requests for this container. For example, 'cpu=100m,memory=256Mi'

--restart="Always"
    The restart policy for this Pod. Legal values [Always, OnFailure, Never]. If set to 'Always' a deployment is created for this pod, if set to OnFailure or Never, a job is created for this pod and --replicas must be 1. Default 'Always'

--rm=false
    If true, delete resources created in this command for attached containers.

--save-config=false
    If true, the configuration of current object will be saved in its annotation. This is useful when you want to perform kubectl apply on this object in the future.

--service-generator="service/v2"
    The name of the generator to use for creating a service. Only used if --expose is true

--service-overrides=""
    An inline JSON override for the generated service object. If this is non-empty, it is used to override the generated object. Requires that the object supply a valid apiVersion field. Only used if --expose is true.

-a, --show-all=false
    When printing, show all resources (default hide terminated pods.)

--show-labels=false
    When printing, show all labels as the last column (default hide labels column)

--sort-by=""
    If non-empty, sort list types using this field specification. The field specification is expressed as a JSONPath expression (e.g. '{.metadata.name}'). The field in the API resource specified by this JSONPath expression must be an integer or a string.

-i, --stdin=false
    Keep stdin open on the container(s) in the pod, even if nothing is attached.

--template=""
    Template string or path to template file to use when -o=go-template, -o=go-template-file. The template format is golang templates [ ⟨http://golang.org/pkg/text/template/#pkg-overview⟩].

--tty=false
    Allocated a TTY for each container in the pod. Because -t is currently shorthand for --template, -t is not supported for --tty. This shorthand is deprecated and we expect to adopt -t for --tty soon.

OPTIONS INHERITED FROM PARENT COMMANDS

--alsologtostderr=false
    log to standard error as well as files

--api-version=""
    The API version to use when talking to the server

--certificate-authority=""
    Path to a cert. file for the certificate authority.

--client-certificate=""
    Path to a client certificate file for TLS.

--client-key=""
    Path to a client key file for TLS.

--cluster=""
    The name of the kubeconfig cluster to use

--context=""
    The name of the kubeconfig context to use

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure.

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-dir=""
    If non-empty, write log files in this directory

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--match-server-version=false
    Require server version to match client version

--namespace=""
    If present, the namespace scope for this CLI request.

--password=""
    Password for basic authentication to the API server.

-s, --server=""
    The address and port of the Kubernetes API server

--stderrthreshold=2
    logs at or above this threshold go to stderr

--token=""
    Bearer token for authentication to the API server.

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server.

--v=0
    log level for V logs

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

EXAMPLE

    # Start a single instance of nginx.
    kubectl run nginx --image=nginx
    # Start a single instance of hazelcast and let the container expose port 5701 .
    kubectl run hazelcast --image=hazelcast --port=5701
    # Start a single instance of hazelcast and set environment variables "DNS_DOMAIN=cluster" and "POD_NAMESPACE=default" in the container.
    kubectl run hazelcast --image=hazelcast --env="DNS_DOMAIN=cluster" --env="POD_NAMESPACE=default"
    # Start a replicated instance of nginx.
    kubectl run nginx --image=nginx --replicas=5
    # Dry run. Print the corresponding API objects without creating them.
    kubectl run nginx --image=nginx --dry-run
    # Start a single instance of nginx, but overload the spec of the deployment with a partial set of values parsed from JSON.
    kubectl run nginx --image=nginx --overrides='{ "apiVersion": "v1", "spec": { ... } }'
    # Start a single instance of busybox and keep it in the foreground, don't restart it if it exits.
    kubectl run -i --tty busybox --image=busybox --restart=Never
    # Start the nginx container using the default command, but use custom arguments (arg1 .. argN) for that command.
    kubectl run nginx --image=nginx -- <arg1> <arg2> ... <argN>
    # Start the nginx container using a different command and custom arguments.
    kubectl run nginx --image=nginx --command -- <cmd> <arg1> ... <argN>
    # Start the perl container to compute π to 2000 places and print it out.
    kubectl run pi --image=perl --restart=OnFailure -- perl -Mbignum=bpi -wle 'print bpi(2000)'

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!